/* Copyright (c) 1997, MpegTV LLC */
#ifndef _xthread_h
#define _xthread_h
#ifndef lint
static const char rcsid_xthread_h[] = "$Header: /net/hopkins/home/tristan/mpeg/include/RCS/xthread.h,v 1.1 1999/01/30 09:13:40 tristan Exp $";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

/* xthread is an abstract thread layer based on (a subset of) pthread */

#include <pthread.h>

typedef pthread_t xthread_t;

typedef pthread_mutex_t xthread_mutex_t;
#define XTHREAD_MUTEX_INITIALIZER PTHREAD_MUTEX_INITIALIZER

typedef pthread_cond_t xthread_cond_t;

typedef pthread_attr_t xthread_attr_t;

typedef pthread_once_t xthread_once_t;
#define XTHREAD_ONCE_INIT PTHREAD_ONCE_INIT

typedef pthread_key_t xthread_key_t;

#define xthread_create(thread, attr, start_routine, arg) pthread_create(thread, attr, start_routine, arg)

#define xthread_exit(retval) pthread_exit(retval)

#define xthread_self() pthread_self()

#define xthread_once(once_control, init_routine) pthread_once(once_control, init_routine)

#define xthread_attr_init(attr) pthread_attr_init(attr)

#define xthread_attr_setscope(attr, scope) pthread_attr_setscope(attr, scope)
#define XTHREAD_SCOPE_SYSTEM PTHREAD_SCOPE_SYSTEM

#define xthread_attr_setdetachstate(attr, detachstate) pthread_attr_setdetachstate(attr, detachstate)
#define XTHREAD_CREATE_DETACHED PTHREAD_CREATE_DETACHED

#define xthread_mutex_init(mutex, mutex_attr) pthread_mutex_init(mutex, mutex_attr)  
#define xthread_mutex_lock(mutex) pthread_mutex_lock(mutex)
#define xthread_mutex_unlock(mutex) pthread_mutex_unlock(mutex)

#define xthread_cond_init(cond, cond_attr) pthread_cond_init(cond, cond_attr)  
#define xthread_cond_signal(cond) pthread_cond_signal(cond)
#define xthread_cond_wait(cond, mutex) pthread_cond_wait(cond, mutex)

#define xthread_sigmask(how, newmask, oldmask) pthread_sigmask(how, newmask, oldmask) 

#define xthread_key_create(key, destr_function) pthread_key_create(key, destr_function)
#define xthread_getspecific(key) pthread_getspecific(key)
#define xthread_setspecific(key, pointer) pthread_setspecific(key, pointer)

#endif /* _xthread_h */


